//------------------------------------------------------------
// NXT NicoSensor for ATtiny26L  by takuya matsubara
// http://nicotak.com
// ver 3
//------------------------------------------------------------
#include <avr/io.h>
#include "softi2cs.h"
#include "adc.h"
#include "sio.h"	//debug

#define MODE_NORMAL 0	//
#define MODE_IR     1	//
#define MODE_PSD    2	// Sharp GP2D12
#define MODE_TEMP   3	//
#define MODE_ACC    4	// Accelerometers KXM52-1050


#define MYSLA  0x02    // slave addressiUltrasonicj

#define VALMIN 1	//Ultrasonic cm. min
#define VALMAX 254	//Ultrasonic cm. max
#define ADCMAX 1023 //AD count max
#define ADVMAX 460	//AVcc Volt. [x10mV]


void waitloop(long i)
{
    while(i-- > 0){
    }
}

int cnt_to_volt(int val)
{
	return((int)((ADVMAX * (long)val) >> 10));	// dɕϊ 0`460[x10mV]
}

#define LED_PORT   PORTB   // |[g
#define LED_DDR    DDRB    // o͐ݒ
#define LED_BIT    6       // rbgԍ
#define LED_ON     LED_PORT|=(1<<LED_BIT)
#define LED_OFF    LED_PORT&=~(1<<LED_BIT)

#define MODE_BIT 5

int main(void)
{
    unsigned char slaw;
    unsigned char cmd;
    unsigned char cmd2;
    unsigned char ackdat;
    unsigned char modenum;
    int val;

	PORTA |= (0b111 << MODE_BIT);	//pullup PortA5`7

    LED_DDR |= (1<<LED_BIT);
	LED_ON;

    i2c_init();
    ad_init(0);
	sio_init();

    waitloop(400000);
	modenum = (PINA >> MODE_BIT) ^ 0b111;
	sio_tx('M');			//debug
	sio_tx('0'+modenum);	//debug
	LED_OFF;

    while(1){

        while(1){
            i2c_start();               // }X^̐ڑ҂
            slaw = i2c_read_byte();    // AhXM
            if (slaw == MYSLA) {       // AhXv̏ꍇA
                i2c_write_ack();    // ACKM
                break;
            } else {                   // AhXsv̏ꍇA
                i2c_write_nack();    // NACKM
            }
        }
		LED_ON;

        cmd = i2c_read_byte();         // R}hM
        i2c_write_ack();    // ACKM

        switch(cmd){
//        case 0x41:
//            cmd2 = i2c_read_byte();    // f[^Mî܂ܔjj
//            i2c_write_ack();    // ACKM
//            break;

        case 0x42:
            i2c_start();               // ʐMĊJ
            cmd2 = i2c_read_byte();    // AhXM
            i2c_write_ack();    // ACKM

			val = ad_get();		//JEgl擾
			if(modenum == MODE_NORMAL){
        	    val >>= 2;		//JEgl(0`1023)𑪒l(0`255)ɕϊ
			}else if(modenum == MODE_IR){

        	    val += 128;    // JEgl(0`1023)𑪒l(0`127)ɕϊ
				ad_init(1);
            	val -= ad_get();    // JEgl(0`1023)𑪒l(0`127)ɕϊ
				ad_init(0);

			}else if(modenum == MODE_PSD){
//				val = (int)((ADVMAX * (long)val) >> 10);	// dɕϊ 0`460[x10mV]
				val = cnt_to_volt(val);	// dɕϊ 0`460[x10mV]
				if(val)
					val = (3360 - (val*4))/val;	//ɕϊ[cm]
				else
					val=VALMAX;
			}else if(modenum == MODE_ACC){

	            // (Vcc/2)}(Vcc/5)
				// (1024/2)}(1024/5) = 512}204
				val -= 308;
				val = (int)(253 * (long)val / (716 - 308))+1;

			}else if(modenum == MODE_TEMP){
				val = cnt_to_volt(val);	// dɕϊ 0`460[x10mV]
			}
            if(val < VALMIN) val=VALMIN;
            if(val > VALMAX) val=VALMAX;
            i2c_write_byte((unsigned char)val);  // lM
            ackdat = i2c_read_bit(1);
            i2c_sda_low();
            break;
        default:
            cmd2 = i2c_read_byte();    // f[^Mî܂ܔjj
            i2c_write_ack();    // ACKM
            break;
        }
        i2c_stop();
		LED_OFF;
//		sio_tx('0');	//debug
//		sio_txhex(cmd);	//debug
    }
}
