//------------------------------------------------------------
// \tgEFAɂI2CʐM֐(slavep) by Takuya Matsubara
//------------------------------------------------------------
#include <avr/io.h>
#include "softi2cs.h"

#define I2C_PORT   PORTB   // |[g
#define I2C_PIN    PINB    // ̓|[g
#define I2C_DDR    DDRB    // o͐ݒ
#define SCL        5       // rbgԍ
#define SDA        4       // rbgԍ

char i2c_err;

//------------------------------------|[g
void i2c_init(void)
{
    I2C_DDR &= ~(1<<SDA);    // SDA ͂ɐݒ
    I2C_DDR &= ~(1<<SCL);    // SCL ͂ɐݒ
}

#define TIMEOUTMAX 5000
//------------------------------------SCL Hx҂
void i2c_scl_waith(void)
{
	int timeout=0;

	  // SCL=H ҂
    while((I2C_PIN & (1<<SCL))==0){
		timeout++;
		if(timeout > TIMEOUTMAX){
			i2c_err=1;
			break;
		}
	}
}

//------------------------------------SCL Lx҂
void i2c_scl_waitl(void)
{
	int timeout=0;

  	// SCL=L ҂
    while((I2C_PIN & (1<<SCL))!=0){
		timeout++;
		if(timeout > TIMEOUTMAX){
			i2c_err=1;
			break;
		}
	}
}

//------------------------------------SDAHigh
void i2c_sda_high(void)
{
    I2C_PORT |= (1<<SDA);
    I2C_DDR |= (1<<SDA);
}

//------------------------------------SDALow
void i2c_sda_low(void)
{
    I2C_PORT &= ~(1<<SDA);
    I2C_DDR |= (1<<SDA);
}

//------------------------------------EGCg
void i2c_delay(void)
{
    int i=1;
    while(i-- > 0){
    }
}

//------------------------------------MJn҂/MĊJ҂
void i2c_start(void)
{
	i2c_err=0;
    I2C_DDR &= ~(1<<SDA);
    while((I2C_PIN & (1<<SDA))==0);  // SDA=H ҂
    i2c_scl_waith();                 // SCL=H ҂
    while((I2C_PIN & (1<<SDA))!=0);  // SDA=L ҂
    i2c_scl_waitl();                 // SCL=L ҂
}

//------------------------------------MI҂
void i2c_stop(void)
{
    I2C_DDR &= ~(1<<SDA);
    i2c_scl_waith();                 // SCL=H ҂
    while((I2C_PIN & (1<<SDA))==0);  // SDA=H ҂
}

void i2c_write_ack(void)
{
   i2c_sda_low();
   i2c_scl_waith();
   i2c_scl_waitl();
}


void i2c_write_nack(void)
{
   i2c_sda_high();
   i2c_scl_waith();
   i2c_scl_waitl();
}



//---------------------------------rbgM(:Mrbg)
unsigned char i2c_read_bit(char cnt)
{
    unsigned char data=0;

    I2C_DDR &= ~(1<<SDA);
    while(cnt > 0)
    {
        data <<=1;
        i2c_scl_waith();

        if (I2C_PIN & (1<<SDA))
            data |= 1;

        cnt--;
        i2c_scl_waitl();
    }
    return(data);
}

//---------------------------------- 1oCgM
void i2c_write_byte(unsigned char data)
{
	char cnt = 8;
	if(i2c_err)return;

    while(cnt--)
    {
        if(data & 0x80)
            i2c_sda_high();
        else
            i2c_sda_low();

        i2c_scl_waith();
        data <<= 1;
        i2c_scl_waitl();
    }
}

//---------------------------------- 1oCgM
unsigned char i2c_read_byte(void)
{
	if(i2c_err)return(0);
    return(i2c_read_bit(8));
}

